## prometheus-node-exporter 1.9.1

=== Makefile ===
# Copyright 2015 The Prometheus Authors
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Ensure that 'all' is the default target otherwise it will be the first target from Makefile.common.
all::

# Needs to be defined before including Makefile.common to auto-generate targets
DOCKER_ARCHS ?= amd64 armv7 arm64 ppc64le s390x

include Makefile.common

PROMTOOL_VERSION ?= 2.30.0
PROMTOOL_URL     ?= https://github.com/prometheus/prometheus/releases/download/v$(PROMTOOL_VERSION)/prometheus-$(PROMTOOL_VERSION).$(GO_BUILD_PLATFORM).tar.gz
PROMTOOL         ?= $(FIRST_GOPATH)/bin/promtool

DOCKER_IMAGE_NAME       ?= node-exporter
MACH                    ?= $(shell uname -m)

STATICCHECK_IGNORE =

ifeq ($(GOHOSTOS), linux)
	test-e2e := test-e2e
else
	test-e2e := skip-test-e2e
endif

# Use CGO for non-Linux builds.
ifeq ($(GOOS), linux)
	PROMU_CONF ?= .promu.yml
else
	ifndef GOOS
		ifeq ($(GOHOSTOS), linux)
			PROMU_CONF ?= .promu.yml
		else
			PROMU_CONF ?= .promu-cgo.yml
		endif
	else
		# Do not use CGO for openbsd/amd64 builds
		ifeq ($(GOOS), openbsd)
			ifeq ($(GOARCH), amd64)
				PROMU_CONF ?= .promu.yml
			else
				PROMU_CONF ?= .promu-cgo.yml
			endif
		else
			PROMU_CONF ?= .promu-cgo.yml
		endif
	endif
endif

PROMU := $(FIRST_GOPATH)/bin/promu --config $(PROMU_CONF)

e2e-out-64k-page = collector/fixtures/e2e-64k-page-output.txt
e2e-out = collector/fixtures/e2e-output.txt
ifeq ($(MACH), ppc64le)
	e2e-out = $(e2e-out-64k-page)
endif
ifeq ($(MACH), aarch64)
	e2e-out = $(e2e-out-64k-page)
endif

# 64bit -> 32bit mapping for cross-checking. At least for amd64/386, the 64bit CPU can execute 32bit code but not the other way around, so we don't support cross-testing upwards.
cross-test = skip-test-32bit
define goarch_pair
	ifeq ($$(GOHOSTOS),linux)
		ifeq ($$(GOHOSTARCH),$1)
			GOARCH_CROSS = $2
			cross-test = test-32bit
		endif
	endif
endef

# By default, "cross" test with ourselves to cover unknown pairings.
$(eval $(call goarch_pair,amd64,386))
$(eval $(call goarch_pair,mips64,mips))
$(eval $(call goarch_pair,mips64el,mipsel))

all:: vet checkmetrics checkrules common-all $(cross-test) $(test-e2e)

.PHONY: test
test: collector/fixtures/sys/.unpacked collector/fixtures/udev/.unpacked
	@echo ">> running tests"
	$(GO) test -short $(test-flags) $(pkgs)

.PHONY: test-32bit
test-32bit: collector/fixtures/sys/.unpacked collector/fixtures/udev/.unpacked
	@echo ">> running tests in 32-bit mode"
	@env GOARCH=$(GOARCH_CROSS) $(GO) test $(pkgs)

.PHONY: skip-test-32bit
skip-test-32bit:
	@echo ">> SKIP running tests in 32-bit mode: not supported on $(GOHOSTOS)/$(GOHOSTARCH)"

%/.unpacked: %.ttar
	@echo ">> extracting fixtures"
	if [ -d $(dir $@) ] ; then rm -rf $(dir $@) ; fi
	./ttar -C $(dir $*) -x -f $*.ttar
	touch $@

update_fixtures:
	rm -vf collector/fixtures/sys/.unpacked
	./ttar -C collector/fixtures -c -f collector/fixtures/sys.ttar sys
	rm -vf collector/fixtures/udev/.unpacked
	./ttar -C collector/fixtures -c -f collector/fixtures/udev.ttar udev

.PHONY: tools
tools:
	@rm ./tools/tools >/dev/null 2>&1 || true
	@$(GO) build -o tools ./tools/...

.PHONY: test-e2e
test-e2e: build collector/fixtures/sys/.unpacked collector/fixtures/udev/.unpacked tools
	@echo ">> running end-to-end tests"
	./end-to-end-test.sh

.PHONY: skip-test-e2e
skip-test-e2e:
	@echo ">> SKIP running end-to-end tests on $(GOHOSTOS)"

.PHONY: checkmetrics
checkmetrics: $(PROMTOOL)
	@echo ">> checking metrics for correctness"
	./checkmetrics.sh $(PROMTOOL) $(e2e-out)
	./checkmetrics.sh $(PROMTOOL) $(e2e-out-64k-page)

.PHONY: checkrules
checkrules: $(PROMTOOL)
	@echo ">> checking rules for correctness"
	find . -name "*rules*.yml" | xargs -I {} $(PROMTOOL) check rules {}

.PHONY: test-docker
test-docker:
	@echo ">> testing docker image"
	./test_image.sh "$(DOCKER_REPO)/$(DOCKER_IMAGE_NAME)-linux-amd64:$(DOCKER_IMAGE_TAG)" 9100

.PHONY: promtool
promtool: $(PROMTOOL)

$(PROMTOOL):
	mkdir -p $(FIRST_GOPATH)/bin
	curl -fsS -L $(PROMTOOL_URL) | tar -xvzf - -C $(FIRST_GOPATH)/bin --strip 1 "prometheus-$(PROMTOOL_VERSION).$(GO_BUILD_PLATFORM)/promtool"

=== debian/changelog ===
prometheus-node-exporter (1.9.1-1) unstable; urgency=medium

  * New upstream release
  * Refresh packaging according to latest dh-make-golang template
  * Drop unused golang-github-pkg-errors-dev Build-Depends
  * Bump Standards-Version to 4.7.2 (no changes)

 -- Daniel Swarbrick <dswarbrick@debian.org>  Tue, 12 Aug 2025 20:17:15 +0000

=== debian/control ===
Source: prometheus-node-exporter
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Martina Ferrari <tina@debian.org>,
           Daniel Swarbrick <dswarbrick@debian.org>,
           Benjamin Drung <bdrung@debian.org>,
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-sequence-golang,
               golang-any,
               golang-dbus-dev,
               golang-github-beevik-ntp-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-dennwc-btrfs-dev,
               golang-github-ema-qdisc-dev,
               golang-github-hashicorp-go-envparse-dev,
               golang-github-hodgesds-perf-utils-dev,
               golang-github-josharian-native-dev,
               golang-github-jsimonetti-rtnetlink-dev,
               golang-github-mattn-go-xmlrpc-dev,
               golang-github-mdlayher-ethtool-dev,
               golang-github-mdlayher-netlink-dev,
               golang-github-mdlayher-wifi-dev,
               golang-github-opencontainers-selinux-dev,
               golang-github-prometheus-client-golang-dev (>= 1.19.0),
               golang-github-prometheus-client-model-dev,
               golang-github-prometheus-common-dev (>= 0.26),
               golang-github-prometheus-community-go-runit-dev,
               golang-github-prometheus-exporter-toolkit-dev (>= 0.13.0),
               golang-github-prometheus-procfs-dev (>= 0.15.1),
               golang-github-safchain-ethtool-dev (>= 0.0~git20201023.874930c),
               golang-golang-x-exp-dev,
               golang-golang-x-sys-dev,
               golang-gopkg-alecthomas-kingpin.v2-dev,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/prometheus-node-exporter
Vcs-Git: https://salsa.debian.org/go-team/packages/prometheus-node-exporter.git
Homepage: https://github.com/prometheus/node_exporter
XS-Go-Import-Path: github.com/prometheus/node_exporter

Package: prometheus-node-exporter
Section: net
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: dbus,
            prometheus-node-exporter-collectors,
Static-Built-Using: ${misc:Static-Built-Using}
Description: Prometheus exporter for machine metrics
 Prometheus exporter for machine metrics, written in Go with pluggable metric
 collectors.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to enable verbose mode.
#export DH_VERBOSE = 1

export DH_GOLANG_EXCLUDES := tools
export DH_GOLANG_INSTALL_EXTRA := collector/fixtures

METAPKG := github.com/prometheus/common

BRANCH     := debian/sid
USER       := team+pkg-go@tracker.debian.org
BUILD_DATE := $(shell date --utc --date='@$(SOURCE_DATE_EPOCH)' \
    +%Y%m%d-%H:%M:%S)
GO_VERSION := $(shell go version | sed 's/go version \(\S*\).*/\1/')
BUILDTAGS  :=
BUILDFLAGS  = -tags "$(BUILDTAGS)" -ldflags \
  " -X $(METAPKG)/version.Version=$(DEB_VERSION_UPSTREAM)\
    -X $(METAPKG)/version.Revision=$(DEB_VERSION)\
    -X $(METAPKG)/version.Branch=$(BRANCH)\
    -X $(METAPKG)/version.BuildUser=$(USER)\
    -X $(METAPKG)/version.BuildDate=$(BUILD_DATE)\
    -X $(METAPKG)/version.GoVersion=$(GO_VERSION)"

%:
	dh $@ --builddirectory=_build --buildsystem=golang

# ZFS (or its tests) are not working in 32-bit arches.
include /usr/share/dpkg/architecture.mk
ifeq ($(DEB_HOST_ARCH_BITS),32)
BUILDTAGS += nozfs
endif

BINNAME := $(DEB_SOURCE)

override_dh_auto_build:
	dh_auto_build -- $(BUILDFLAGS)
	# Rename the binary to match the debian package.
	mv -v _build/bin/node_exporter _build/bin/$(BINNAME)

override_dh_auto_test:
	./ttar -C _build/src/github.com/prometheus/node_exporter/collector/fixtures \
      -x -f collector/fixtures/sys.ttar
	./ttar -C _build/src/github.com/prometheus/node_exporter/collector/fixtures \
      -x -f collector/fixtures/udev.ttar
	dh_auto_test -- $(BUILDFLAGS)

MAN_WHATIS := $(BINNAME) \\- Prometheus exporter for machine metrics
MAN_PROG := $(shell echo $(BINNAME) | tr [:lower:] [:upper:])
MAN_DATE := $(shell date --utc --date='@$(SOURCE_DATE_EPOCH)' '+%B %Y')

execute_before_dh_installman:
	_build/bin/$(BINNAME) --help-man > _build/$(BINNAME).1
	# Fix title header and footer.
	sed -i '/^.TH .*/c.TH $(MAN_PROG) "1" "$(MAN_DATE)" "$(DEB_SOURCE) $(DEB_VERSION_UPSTREAM)" "Prometheus"/' \
        _build/$(BINNAME).1
	# Remove build user/build date/go version headers, which is ugly.
	sed -i '/^  /d' _build/$(BINNAME).1
	# Fix whatis entry.
	sed -i '/^.SH "NAME"/,+1c.SH "NAME"\n$(MAN_WHATIS)' _build/$(BINNAME).1
	# Remove default values, as they create unwieldy long lines.
	sed -i 's/\\fB--\(.*\)=".*"\\fR/\\fB--\1\\fR/' _build/$(BINNAME).1

override_dh_auto_install:
	dh_auto_install -- --no-source

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/prometheus/node_exporter/tags .*/v?(\d\S*)\.tar\.gz debian

## prometheus-node-exporter 1.10.2

=== debian/changelog ===
prometheus-node-exporter (1.10.2-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * Drop unused golang-github-josharian-native-dev Build-Depends
  * Bump Build-Depends version constraints
    - golang-github-prometheus-client-golang-dev (>= 1.23.2)
    - golang-github-prometheus-common-dev (>= 0.67.1)
    - golang-github-prometheus-procfs-dev (>= 0.19.0)

 -- Daniel Swarbrick <dswarbrick@debian.org>  Wed, 31 Dec 2025 00:04:52 +0000

=== debian/control ===
--- 
+++ 
@@ -16,19 +16,18 @@
                golang-github-ema-qdisc-dev,
                golang-github-hashicorp-go-envparse-dev,
                golang-github-hodgesds-perf-utils-dev,
-               golang-github-josharian-native-dev,
                golang-github-jsimonetti-rtnetlink-dev,
                golang-github-mattn-go-xmlrpc-dev,
                golang-github-mdlayher-ethtool-dev,
                golang-github-mdlayher-netlink-dev,
                golang-github-mdlayher-wifi-dev,
                golang-github-opencontainers-selinux-dev,
-               golang-github-prometheus-client-golang-dev (>= 1.19.0),
+               golang-github-prometheus-client-golang-dev (>= 1.23.2),
                golang-github-prometheus-client-model-dev,
-               golang-github-prometheus-common-dev (>= 0.26),
+               golang-github-prometheus-common-dev (>= 0.67.1),
                golang-github-prometheus-community-go-runit-dev,
                golang-github-prometheus-exporter-toolkit-dev (>= 0.13.0),
-               golang-github-prometheus-procfs-dev (>= 0.15.1),
+               golang-github-prometheus-procfs-dev (>= 0.19.0),
                golang-github-safchain-ethtool-dev (>= 0.0~git20201023.874930c),
                golang-golang-x-exp-dev,
                golang-golang-x-sys-dev,
